&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS butt-file1 FILL-tlbFile BUTTON-3 
&Scoped-Define DISPLAYED-OBJECTS FILL-tlbFile 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON butt-file1 
     LABEL "Browse..." 
     SIZE 15 BY 1.14.

DEFINE BUTTON BUTTON-3 
     LABEL "Create Pre-Processor File" 
     SIZE 31 BY 1.14.

DEFINE VARIABLE FILL-tlbFile AS CHARACTER FORMAT "X(256)":U 
     LABEL "Type Library" 
     VIEW-AS FILL-IN 
     SIZE 83.2 BY .95 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     butt-file1 AT ROW 1.48 COL 98 WIDGET-ID 4
     FILL-tlbFile AT ROW 1.57 COL 12.6 COLON-ALIGNED WIDGET-ID 2
     BUTTON-3 AT ROW 3.38 COL 32 WIDGET-ID 10
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 113.8 BY 16 WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Create Constants File"
         HEIGHT             = 4.33
         WIDTH              = 114
         MAX-HEIGHT         = 16
         MAX-WIDTH          = 117.6
         VIRTUAL-HEIGHT     = 16
         VIRTUAL-WIDTH      = 117.6
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
   FRAME-NAME                                                           */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Create Constants File */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Create Constants File */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME butt-file1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL butt-file1 C-Win
ON CHOOSE OF butt-file1 IN FRAME DEFAULT-FRAME /* Browse... */
DO:
  DEF VAR vOK AS LOG NO-UNDO.
  SYSTEM-DIALOG GET-FILE fill-tlbFile
        TITLE      "Open"
        FILTERS    "TypeLib Files (*.tlb,*.olb,*.dll,*.exe,*.ocx)"   "*.tlb,*.olb,*.dll,*.exe,*.ocx",
                   "All Files (*.*)"   "*.*"
        MUST-EXIST
        USE-FILENAME
        UPDATE vOK.
  IF vOk THEN DISPLAY fill-tlbFile WITH FRAME {&FRAME-NAME}.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BUTTON-3
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BUTTON-3 C-Win
ON CHOOSE OF BUTTON-3 IN FRAME DEFAULT-FRAME /* Create Pre-Processor File */
DO:
  DEF VAR chTlib AS COM-HANDLE.
  DEF VAR chConstant AS COM-HANDLE.
  DEF VAR tlbFile AS CHAR INIT "C:\Program Files\Common Files\Microsoft Shared\OFFICE11\mso.dll".
  DEF VAR i AS INT NO-UNDO.
  DEF VAR Y AS INT NO-UNDO.
  DEF VAR vOK AS LOG NO-UNDO.
  DEF VAR vOutFile AS CHAR NO-UNDO.
  DEF VAR basename AS CHAR NO-UNDO.
  
  FILE-INFO:FILE-NAME = fill-tlbfile.

  IF FILE-INFO:FILE-NAME EQ "" THEN DO:
    MESSAGE "You must pick a type library file"
      VIEW-AS ALERT-BOX ERROR.
    APPLY "ENTRY" TO fill-tlbFile.
    RETURN.
  END.
  basename = SUBSTRING(FILE-INFO:FULL-PATHNAME,R-INDEX(fill-tlbFile,"\") + 1).

  vOutFile = SESSION:TEMP-DIRECTORY +
    ENTRY(1,basename,".") + ".i".
  
  SYSTEM-DIALOG GET-FILE vOutFile
        TITLE      "Save As"
        FILTERS    "Progress Include File (*.i)"   "*.i",
                   "All Files (*.*)"   "*.*"
        USE-FILENAME
        SAVE-AS
        ASK-OVERWRITE
        UPDATE vOK.
  
  IF NOT vOK THEN RETURN.
  
  
  CREATE "tli.typelibinfo" chTlib.
  chTlib:containingFile = fill-tlbFile.
  
  OUTPUT TO value(vOutFile).
  RUN make_header.
  DO i = 1 TO chTlib:constants:COUNT:
    chConstant = chTlib:constants:ITEM(i).
    PUT UNFORMATTED "/*" chConstant:NAME "*/" SKIP.
    DO Y = 1 TO chConstant:members:COUNT:
      /* Excel contains a couple of contants that begin with an underscore
         which is an invalid first character for a pre-processor */
      IF chConstant:members:ITEM(Y):NAME BEGINS "_" THEN NEXT.
      PUT UNFORMATTED 
        "&GLOBAL-DEFINE "
        chConstant:members:ITEM(Y):NAME " "
        chConstant:members:ITEM(Y):VALUE SKIP.

    END.
    RELEASE OBJECT chConstant.
  END.
  OUTPUT CLOSE.
  RELEASE OBJECT chTlib.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY FILL-tlbFile 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE butt-file1 FILL-tlbFile BUTTON-3 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Make_Header C-Win 
PROCEDURE Make_Header :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  PUT UNFORMATTED

    "/" FILL("*",60) SKIP
 "   This file generated by typelibrary.w." skip
 "   Author: Tom Bergman" SKIP
 "   Type Library Name: " FILE-INFO:FULL-PATHNAME SKIP
 "   Type Library File Date: "  FILE-INFO:FILE-CREATE-DATE SKIP
 "   Type Library File Time: "  string(FILE-INFO:FILE-CREATE-TIME,"HH:MM:SS") SKIP
 "   Type Library File Size: "  FILE-INFO:FILE-SIZE SKIP

     FILL("*",60) "/" SKIP.



  
  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

